#include <OneWire.h>


OneWire  ds(5);  // on pin 5 (a 4.7K resistor is necessary)
int time;
int contador;
char buffer[80]; 

String  temperaturaX[5];

const int ledPin =  13;
const int ledReset =  12;

String response;
int z;
String webpage;

#define DEBUG 0

//  WIFI_SSID  WIFI_CLAVE 
String cmd="AT+CWJAP=\"modem\",\"contraseña\"\r\n";  

int connectWiFi()
{
  int error;
    error=0;
    Serial.println("WIFI_CONECTAR");   
    Serial3.println("AT+RST");  readS(4000);
    if(!sendOrden("AT+CWMODE=1\r\n","OK","AT+CWMODE=1",200)) error++;  
  
    if(!sendOrden(cmd,"OK","setamodem",2000)) error++;  
    if(!sendOrden("AT+CWMODE=3\r\n","OK","AT+CWMODE=3",200)) error++;    
    if(!sendOrden("AT+CIFSR\r\n","OK","AT+CIFSR",200)) error++;    
    if(!sendOrden("AT+CIPMUX=1\r\n","OK","AT+CIPMUX=1",200)) error++;    
    if(!sendOrden("AT+CIPSERVER=1,4040\r\n","OK","AT+CIPSERVER",200)) error++; 
    if(!sendOrden("AT+CIPSTO=30\r\n","OK","AT+CIPSTO=15",200)) error++; 
    Serial.println("FIN_WIFI"); 
    return(error);  
}

// orden AT, respuesta que deberia salir, mensage de respuesta, retardo
int sendOrden(String orden,String respuesta, String mensage, int retardo)
{
 int zz;
  Serial3.print(orden);
   for(zz=0;zz<5;zz++)
     {
      readS(retardo); 
      if(response.indexOf(respuesta)>0) 
          { Serial.println("_ok_" + mensage); return(1); } 
        else
          {Serial.println("_error_" + mensage);  }
     }
  return(0);
}



void readS( int timeout)
{
    response = "";
    while(timeout)
    {
      while(Serial3.available())
      {
        char c = Serial3.read(); 
        response+=c;
      } 
     delay(1); timeout--; 
    }    
    #if DEBUG
      Serial.print("DEBUG__"); Serial.print(response); 
    #endif
}


void setup()
  {  
     pinMode(ledReset, OUTPUT);
     pinMode(ledPin, OUTPUT);
     digitalWrite(ledPin, LOW); delay(200);
     digitalWrite(ledReset, HIGH); delay(200);
     Serial.begin(9600);
     Serial3.begin(9600);     
         
     z=connectWiFi();
     Serial.print("ERRORES de conexion=");Serial.println(z);
     if(z>0)
       {
         digitalWrite(ledPin, LOW); delay(200); 
       }
       else
       { 
         digitalWrite(ledPin, HIGH); delay(200);
       }
     time=1;
  }

void loop()
{ 
  int ipd;
  
    if (Serial3.available())
         {           
          digitalWrite(ledPin, LOW);          
          readS(200);        
          z=response.indexOf("+IPD");
          if(z>0)
              {                           
                Serial.print("Encontrado +IPD en ");  Serial.println(z);
                Serial.print("IPD="); ipd = response.substring(z+5,z+6).toInt(); Serial.println(ipd);
                //espera al OK de fin de cabecera
                sendOrden("","OK","ipd",200);      
                paginaWeb(ipd);
                readS(200);                
              }  
          digitalWrite(ledPin, HIGH);                   
         } 
  
     if (Serial.available())
         {  char c = Serial.read();
            Serial3.print(c);
         }

    delay(1); time--;
    if(time<1)
      {       
       time=30000;
       //dectecta si sigue conectado
        if(!sendOrden("AT+CWJAP?\r\n","OK","conectado",200))
             if(connectWiFi())
               {
                 Serial.println("Reseteo HART");
                 digitalWrite(ledReset, LOW);
                 delay(800);
                 digitalWrite(ledReset, HIGH);            
               }
       //----------------------------
       
        for(contador=1;contador<5;contador++)
          {        
            if(0==getTemp()) 
              {
                for(;contador<5;contador++)temperaturaX[contador]="??,?";
                break;
              }
            temperaturaX[contador]=buffer;
            Serial.print(buffer);  Serial.print(" ");          
          } 
        Serial.println(" ");  
      }
}
   
   

boolean paginaWeb(int ipd)
{   
 
    webpage = "HTTP/1.1 200 OK\r\n";
    webpage += "Content-Type: text/html\r\n";
    webpage += "Connection: close\r\n";
    webpage += "\r\n";
    webpage += "<!DOCTYPE HTML>\r\n";      
    webpage += "<html>\r\n";
    ///inicio  html 
    webpage +="<TITLE>SERVER WEB Arduino + ESP8266 </TITLE>";            
    webpage += "\r\n";
    webpage += "<big><b>Seta43_Arduino_ESP8266</b></big><br><hr>";
    webpage += "\r\n";
    webpage += "<big><big><font color=red><b>";
    
    for(contador=1;contador<5;contador++)
      {        
        webpage += contador;
        webpage += "&ordm;Sensor = ";         
        webpage += temperaturaX[contador];
        webpage += " &ordm;C\r\n<hr>";      
      }    

    webpage += "</b></font></big></big><br>";
    webpage += "xsetaseta@gmail.com<br>\r\n";        
    ///fin html  
    webpage += "</html>\r\n";
    
    sendData(ipd);
}



void sendData( int ipd)
{  
  int z,zz;
   Serial.println("INICIO_WEB");
   String cade1 = "AT+CIPSEND=";
   cade1 += ipd;
   cade1 += ",";
   cade1 += webpage.length();
   cade1 += "\r\n";
    #if DEBUG
       Serial.println("________INI__________");
       Serial.print(cade1);
       Serial.println(webpage);
       Serial.println("________FIN__________"); 
    #endif
 
  if(sendOrden(cade1,"> ",">>",200))
    {
      sendOrden(webpage,"SEND OK","SEND",200);
      sendOrden("AT+CIPCLOSE=0\r\n","OK","AT+CIPCLOSE",200);
      Serial.println("FIN_WEB");
    }
    else
    {
      Serial.println("ERROR_WEB");
    }
}


//______________________________________________________
//ds18B20
int getTemp()
{
  byte data[12];
  byte addr[8];
  int z;
  long  temp;
  byte decimal;

  if ( !ds.search(addr))   { ds.reset_search(); return 0; }
  if ( OneWire::crc8( addr, 7) != addr[7])  { Serial.println("CRC is not valid!"); return -1; }
  if ( addr[0] != 0x10 && addr[0] != 0x28)  { Serial.print("Device is not recognized"); return -1; }

  ds.reset();  ds.select(addr);  ds.write(0x4E);         
  ds.write(0x4B);    
  ds.write(0x46);    
  ds.write(0x7F);    // 12-bit sampling resolution (default)
  //ds.write(0x5F);    // 11-bit
  //ds.write(0x3F);    // 10-bit
  //ds.write(0x1F);    // 9-bit
  // delay(500); 

  ds.reset();  ds.select(addr);  ds.write(0x44,1); // start conversion, with parasite power on at the end
  delay(750);  

  ds.reset();  ds.select(addr);  ds.write(0xBE); // Read Scratchpad
  for ( z = 0; z < 9; z++) data[z] = ds.read();
    
  z = (data[1] << 8) | data[0];
  temp=z;
  temp=(temp*625)/1000;
  z=temp/10;
  decimal=temp-z*10;
  sprintf(buffer,"%d,%d",z,decimal);    
  return 1;
}



